#ifndef tfe_abil_h
#define tfe_abil_h


/* Skill category defines */

#define SKILL_CAT_PHYSICAL          0
#define SKILL_CAT_LANGUAGE          1
#define SKILL_CAT_SPELL             2
#define SKILL_CAT_TRADE             3
#define SKILL_CAT_WEAPON            4
#define MAX_SKILL_CAT               5

#define SKILL_NONE                 -1

/* Physical skill defines*/

#define SKILL_PHY_FIRST            ( ( SKILL_CAT_PHYSICAL << 16 ) |   0 )
#define SKILL_APPRAISE             ( ( SKILL_CAT_PHYSICAL << 16 ) |   0 )
#define SKILL_ASSASSINATE          ( ( SKILL_CAT_PHYSICAL << 16 ) |   1 )
#define SKILL_BACKSTAB             ( ( SKILL_CAT_PHYSICAL << 16 ) |   2 )
#define SKILL_BANDAGE              ( ( SKILL_CAT_PHYSICAL << 16 ) |   3 )
#define SKILL_BASH                 ( ( SKILL_CAT_PHYSICAL << 16 ) |   4 )
#define SKILL_BEAR_GRASP           ( ( SKILL_CAT_PHYSICAL << 16 ) |   5 )
#define SKILL_BERSERK              ( ( SKILL_CAT_PHYSICAL << 16 ) |   6 )
#define SKILL_BLIND_FIGHTING       ( ( SKILL_CAT_PHYSICAL << 16 ) |   7 )
#define SKILL_BUTCHER              ( ( SKILL_CAT_PHYSICAL << 16 ) |   8 )
#define SKILL_CAMOUFLAGE           ( ( SKILL_CAT_PHYSICAL << 16 ) |   9 )
#define SKILL_CAMPING              ( ( SKILL_CAT_PHYSICAL << 16 ) |  10 )
#define SKILL_CHARGE               ( ( SKILL_CAT_PHYSICAL << 16 ) |  11 )
#define SKILL_CLIMB                ( ( SKILL_CAT_PHYSICAL << 16 ) |  12 )
#define SKILL_COUNTER_ATTACK       ( ( SKILL_CAT_PHYSICAL << 16 ) |  13 )
#define SKILL_COVER_TRACKS         ( ( SKILL_CAT_PHYSICAL << 16 ) |  14 )
#define SKILL_CRITICAL_HIT         ( ( SKILL_CAT_PHYSICAL << 16 ) |  15 )
#define SKILL_DEATH_STRIKE         ( ( SKILL_CAT_PHYSICAL << 16 ) |  16 )
#define SKILL_DEMON_SLASH          ( ( SKILL_CAT_PHYSICAL << 16 ) |  17 )
#define SKILL_DISARM               ( ( SKILL_CAT_PHYSICAL << 16 ) |  18 )
#define SKILL_DISGUISE             ( ( SKILL_CAT_PHYSICAL << 16 ) |  19 )
#define SKILL_DODGE                ( ( SKILL_CAT_PHYSICAL << 16 ) |  20 )
#define SKILL_DRAGON_STRIKE        ( ( SKILL_CAT_PHYSICAL << 16 ) |  21 )
#define SKILL_EAGLE_CLAW           ( ( SKILL_CAT_PHYSICAL << 16 ) |  22 )
#define SKILL_EYE_GOUGE            ( ( SKILL_CAT_PHYSICAL << 16 ) |  23 )
#define SKILL_FIFTH                ( ( SKILL_CAT_PHYSICAL << 16 ) |  24 )
#define SKILL_FORAGE               ( ( SKILL_CAT_PHYSICAL << 16 ) |  25 )
#define SKILL_FOURTH               ( ( SKILL_CAT_PHYSICAL << 16 ) |  26 )
#define SKILL_FRENZY               ( ( SKILL_CAT_PHYSICAL << 16 ) |  27 )
#define SKILL_GARROTE              ( ( SKILL_CAT_PHYSICAL << 16 ) |  28 )
#define SKILL_GUARD                ( ( SKILL_CAT_PHYSICAL << 16 ) |  29 )
#define SKILL_HAGGLE               ( ( SKILL_CAT_PHYSICAL << 16 ) |  30 )
#define SKILL_HEIST                ( ( SKILL_CAT_PHYSICAL << 16 ) |  31 )
#define SKILL_HIDE                 ( ( SKILL_CAT_PHYSICAL << 16 ) |  32 )
#define SKILL_INSPECT              ( ( SKILL_CAT_PHYSICAL << 16 ) |  33 )
#define SKILL_KICK                 ( ( SKILL_CAT_PHYSICAL << 16 ) |  34 )
#define SKILL_LAY_HANDS            ( ( SKILL_CAT_PHYSICAL << 16 ) |  35 )
#define SKILL_LOCUST_KICK          ( ( SKILL_CAT_PHYSICAL << 16 ) |  36 )
#define SKILL_MEDITATE             ( ( SKILL_CAT_PHYSICAL << 16 ) |  37 )
#define SKILL_MELEE                ( ( SKILL_CAT_PHYSICAL << 16 ) |  38 )
#define SKILL_MOUNTED_FIGHTING     ( ( SKILL_CAT_PHYSICAL << 16 ) |  39 )
#define SKILL_OFFHAND_ATTACK       ( ( SKILL_CAT_PHYSICAL << 16 ) |  40 )
#define SKILL_OFFHAND_PARRY        ( ( SKILL_CAT_PHYSICAL << 16 ) |  41 )
#define SKILL_PARRY                ( ( SKILL_CAT_PHYSICAL << 16 ) |  42 )
#define SKILL_PEEK                 ( ( SKILL_CAT_PHYSICAL << 16 ) |  43 )
#define SKILL_PICK_LOCK            ( ( SKILL_CAT_PHYSICAL << 16 ) |  44 )
#define SKILL_POWER_STRIKE         ( ( SKILL_CAT_PHYSICAL << 16 ) |  45 )
#define SKILL_UNUSED1              ( ( SKILL_CAT_PHYSICAL << 16 ) |  46 )
#define SKILL_PUNCH                ( ( SKILL_CAT_PHYSICAL << 16 ) |  47 )
#define SKILL_REGENERATION         ( ( SKILL_CAT_PHYSICAL << 16 ) |  48 )
#define SKILL_RESCUE               ( ( SKILL_CAT_PHYSICAL << 16 ) |  49 )
#define SKILL_RIDING               ( ( SKILL_CAT_PHYSICAL << 16 ) |  50 )
#define SKILL_SCAN                 ( ( SKILL_CAT_PHYSICAL << 16 ) |  51 )
#define SKILL_SEARCHING            ( ( SKILL_CAT_PHYSICAL << 16 ) |  52 )
#define SKILL_SECOND               ( ( SKILL_CAT_PHYSICAL << 16 ) |  53 )
#define SKILL_SECOND_OFFHAND       ( ( SKILL_CAT_PHYSICAL << 16 ) |  54 )
#define SKILL_SHADOW_DANCE         ( ( SKILL_CAT_PHYSICAL << 16 ) |  55 )
#define SKILL_SHIELD_BLOCK         ( ( SKILL_CAT_PHYSICAL << 16 ) |  56 )
#define SKILL_SHIELD_STRIKE        ( ( SKILL_CAT_PHYSICAL << 16 ) |  57 )
#define SKILL_SNEAK                ( ( SKILL_CAT_PHYSICAL << 16 ) |  58 )
#define SKILL_SPIN_KICK            ( ( SKILL_CAT_PHYSICAL << 16 ) |  59 )
#define SKILL_STEAL                ( ( SKILL_CAT_PHYSICAL << 16 ) |  60 )
#define SKILL_STUN                 ( ( SKILL_CAT_PHYSICAL << 16 ) |  61 )
#define SKILL_RIPOSTE              ( ( SKILL_CAT_PHYSICAL << 16 ) |  62 )
#define SKILL_SWEEPING_KICK        ( ( SKILL_CAT_PHYSICAL << 16 ) |  63 )
#define SKILL_SWIMMING             ( ( SKILL_CAT_PHYSICAL << 16 ) |  64 )
#define SKILL_THIRD                ( ( SKILL_CAT_PHYSICAL << 16 ) |  65 )
#define SKILL_TIGER_PAW            ( ( SKILL_CAT_PHYSICAL << 16 ) |  66 )
#define SKILL_TRACK                ( ( SKILL_CAT_PHYSICAL << 16 ) |  67 )
#define SKILL_TRANCE               ( ( SKILL_CAT_PHYSICAL << 16 ) |  68 )
#define SKILL_TRANSFER_ENERGY      ( ( SKILL_CAT_PHYSICAL << 16 ) |  69 )
#define SKILL_TRIP                 ( ( SKILL_CAT_PHYSICAL << 16 ) |  70 )
#define SKILL_TUMBLE               ( ( SKILL_CAT_PHYSICAL << 16 ) |  71 )
#define SKILL_UNTRAP               ( ( SKILL_CAT_PHYSICAL << 16 ) |  72 )
#define SKILL_SOFT_73
#define SKILL_SOFT_74
#define SKILL_SOFT_75
#define SKILL_SOFT_76
#define SKILL_HUNT                 ( ( SKILL_CAT_PHYSICAL << 16 ) |  77 )
#define SKILL_SOFT_78
#define SKILL_ESCAPE               ( ( SKILL_CAT_PHYSICAL << 16 ) |  79 )
#define SKILL_FOCUS                ( ( SKILL_CAT_PHYSICAL << 16 ) |  80 )

/* Language skill defines */

#define LANG_FIRST                 ( ( SKILL_CAT_LANGUAGE << 16 ) |   0 )
#define LANG_PRIMAL                ( ( SKILL_CAT_LANGUAGE << 16 ) |   0 )
#define LANG_HUMANIC               ( ( SKILL_CAT_LANGUAGE << 16 ) |   1 )
#define LANG_ELVISH                ( ( SKILL_CAT_LANGUAGE << 16 ) |   2 )
#define LANG_GNOMISH               ( ( SKILL_CAT_LANGUAGE << 16 ) |   3 )
#define LANG_DWARVISH              ( ( SKILL_CAT_LANGUAGE << 16 ) |   4 )
#define LANG_THENNISH              ( ( SKILL_CAT_LANGUAGE << 16 ) |   5 )
#define LANG_ENTISH                ( ( SKILL_CAT_LANGUAGE << 16 ) |   6 )
#define LANG_CENTAUR               ( ( SKILL_CAT_LANGUAGE << 16 ) |   7 )
#define LANG_SLISP                 ( ( SKILL_CAT_LANGUAGE << 16 ) |   8 )
#define LANG_OGRISH                ( ( SKILL_CAT_LANGUAGE << 16 ) |   9 )
#define LANG_TROLLISH              ( ( SKILL_CAT_LANGUAGE << 16 ) |  10 )
#define LANG_ORCISH                ( ( SKILL_CAT_LANGUAGE << 16 ) |  11 )
#define LANG_GOBLISH               ( ( SKILL_CAT_LANGUAGE << 16 ) |  12 )
#define LANG_VYANIAN               ( ( SKILL_CAT_LANGUAGE << 16 ) |  13 )

/* Spell skill defines */

#define SPELL_FIRST                ( ( SKILL_CAT_SPELL << 16 ) |   0 )
#define SPELL_AMNESIA              ( ( SKILL_CAT_SPELL << 16 ) |   0 )
#define SPELL_ANIMATE_CLAY         ( ( SKILL_CAT_SPELL << 16 ) |   1 )
#define SPELL_ANIMATE_DEAD         ( ( SKILL_CAT_SPELL << 16 ) |   2 )
#define SPELL_ARMOR                ( ( SKILL_CAT_SPELL << 16 ) |   3 )
#define SPELL_BANISHMENT           ( ( SKILL_CAT_SPELL << 16 ) |   4 )
#define SPELL_BARKSKIN             ( ( SKILL_CAT_SPELL << 16 ) |   5 )
#define SPELL_BLESS                ( ( SKILL_CAT_SPELL << 16 ) |   6 )
#define SPELL_BLIND                ( ( SKILL_CAT_SPELL << 16 ) |   7 )
#define SPELL_BLINDING_LIGHT       ( ( SKILL_CAT_SPELL << 16 ) |   8 )
#define SPELL_BLINK                ( ( SKILL_CAT_SPELL << 16 ) |   9 )
#define SPELL_BURNING_HANDS        ( ( SKILL_CAT_SPELL << 16 ) |  10 )
#define SPELL_CALL_LIGHTNING       ( ( SKILL_CAT_SPELL << 16 ) |  11 )
#define SPELL_CALM                 ( ( SKILL_CAT_SPELL << 16 ) |  12 )
#define SPELL_CAUSE_CRITICAL       ( ( SKILL_CAT_SPELL << 16 ) |  13 )
#define SPELL_CAUSE_LIGHT          ( ( SKILL_CAT_SPELL << 16 ) |  14 )
#define SPELL_CAUSE_SERIOUS        ( ( SKILL_CAT_SPELL << 16 ) |  15 )
#define SPELL_CHAIN_LIGHTNING      ( ( SKILL_CAT_SPELL << 16 ) |  16 )
#define SPELL_CHILLING_TOUCH       ( ( SKILL_CAT_SPELL << 16 ) |  17 )
#define SPELL_CONFUSE              ( ( SKILL_CAT_SPELL << 16 ) |  18 )
#define SPELL_CONTINUAL_LIGHT      ( ( SKILL_CAT_SPELL << 16 ) |  19 )
#define SPELL_CREATE_FEAST         ( ( SKILL_CAT_SPELL << 16 ) |  20 )
#define SPELL_CREATE_FOOD          ( ( SKILL_CAT_SPELL << 16 ) |  21 )
#define SPELL_CREATE_LIGHT         ( ( SKILL_CAT_SPELL << 16 ) |  22 )
#define SPELL_CREATE_WATER         ( ( SKILL_CAT_SPELL << 16 ) |  23 )
#define SPELL_CURE_BLINDNESS       ( ( SKILL_CAT_SPELL << 16 ) |  24 )
#define SPELL_CURE_CRITICAL        ( ( SKILL_CAT_SPELL << 16 ) |  25 )
#define SPELL_CURE_DISEASE         ( ( SKILL_CAT_SPELL << 16 ) |  26 )
#define SPELL_CURE_LIGHT           ( ( SKILL_CAT_SPELL << 16 ) |  27 )
#define SPELL_CURE_POISON          ( ( SKILL_CAT_SPELL << 16 ) |  28 )
#define SPELL_CURE_SERIOUS         ( ( SKILL_CAT_SPELL << 16 ) |  29 )
#define SPELL_CURSE                ( ( SKILL_CAT_SPELL << 16 ) |  30 )
#define SPELL_DETECT_EVIL          ( ( SKILL_CAT_SPELL << 16 ) |  31 )
#define SPELL_DETECT_GOOD          ( ( SKILL_CAT_SPELL << 16 ) |  32 )
#define SPELL_DETECT_HIDDEN        ( ( SKILL_CAT_SPELL << 16 ) |  33 )
#define SPELL_DETECT_INVISIBLE     ( ( SKILL_CAT_SPELL << 16 ) |  34 )
#define SPELL_DETECT_MAGIC         ( ( SKILL_CAT_SPELL << 16 ) |  35 )
#define SPELL_DISPLACE             ( ( SKILL_CAT_SPELL << 16 ) |  36 )
#define SPELL_DRAIN_LIFE           ( ( SKILL_CAT_SPELL << 16 ) |  37 )
#define SPELL_EAGLE_EYE            ( ( SKILL_CAT_SPELL << 16 ) |  38 )
#define SPELL_FAERIE_FIRE          ( ( SKILL_CAT_SPELL << 16 ) |  39 )
#define SPELL_FEAR                 ( ( SKILL_CAT_SPELL << 16 ) |  40 )
#define SPELL_FIND_FAMILIAR        ( ( SKILL_CAT_SPELL << 16 ) |  41 )
#define SPELL_FIRE_SHIELD          ( ( SKILL_CAT_SPELL << 16 ) |  42 )
#define SPELL_FIREBALL             ( ( SKILL_CAT_SPELL << 16 ) |  43 )
#define SPELL_FREEZE               ( ( SKILL_CAT_SPELL << 16 ) |  44 )
#define SPELL_GIFT_OF_TONGUES      ( ( SKILL_CAT_SPELL << 16 ) |  45 )
#define SPELL_GREATER_ANIMATION    ( ( SKILL_CAT_SPELL << 16 ) |  46 )
#define SPELL_HALLUCINATE          ( ( SKILL_CAT_SPELL << 16 ) |  47 )
#define SPELL_HARM                 ( ( SKILL_CAT_SPELL << 16 ) |  48 )
#define SPELL_HAWKS_VIEW           ( ( SKILL_CAT_SPELL << 16 ) |  49 )
#define SPELL_HEAL                 ( ( SKILL_CAT_SPELL << 16 ) |  50 )
#define SPELL_HOLY_WRATH           ( ( SKILL_CAT_SPELL << 16 ) |  51 )
#define SPELL_ICE_STORM            ( ( SKILL_CAT_SPELL << 16 ) |  52 )
#define SPELL_IDENTIFY             ( ( SKILL_CAT_SPELL << 16 ) |  53 )
#define SPELL_IGNITE_WEAPON        ( ( SKILL_CAT_SPELL << 16 ) |  54 )
#define SPELL_INFRAVISION          ( ( SKILL_CAT_SPELL << 16 ) |  55 )
#define SPELL_INVISIBILITY         ( ( SKILL_CAT_SPELL << 16 ) |  56 )
#define SPELL_LIGHTNING_BOLT       ( ( SKILL_CAT_SPELL << 16 ) |  57 )
#define SPELL_LOCUST_SWARM         ( ( SKILL_CAT_SPELL << 16 ) |  58 )
#define SPELL_MAGIC_MAPPING        ( ( SKILL_CAT_SPELL << 16 ) |  59 )
#define SPELL_MAGIC_MISSILE        ( ( SKILL_CAT_SPELL << 16 ) |  60 )
#define SPELL_MIND_BLADE           ( ( SKILL_CAT_SPELL << 16 ) |  61 )
#define SPELL_MINOR_ENCHANTMENT    ( ( SKILL_CAT_SPELL << 16 ) |  62 )
#define SPELL_MISTS_SLEEP          ( ( SKILL_CAT_SPELL << 16 ) |  63 )
#define SPELL_MYSTIC_SHIELD        ( ( SKILL_CAT_SPELL << 16 ) |  64 )
#define SPELL_NEUTRALIZE           ( ( SKILL_CAT_SPELL << 16 ) |  65 )
#define SPELL_OGRE_STRENGTH        ( ( SKILL_CAT_SPELL << 16 ) |  66 )
#define SPELL_POISON_CLOUD         ( ( SKILL_CAT_SPELL << 16 ) |  67 )
#define SPELL_POLYMORPH            ( ( SKILL_CAT_SPELL << 16 ) |  68 )
#define SPELL_PROTECT_LIFE         ( ( SKILL_CAT_SPELL << 16 ) |  69 )
#define SPELL_PROT_PLANTS          ( ( SKILL_CAT_SPELL << 16 ) |  70 )
#define SPELL_RECALL               ( ( SKILL_CAT_SPELL << 16 ) |  71 )
#define SPELL_REMOVE_CURSE         ( ( SKILL_CAT_SPELL << 16 ) |  72 )
#define SPELL_REPLICATE            ( ( SKILL_CAT_SPELL << 16 ) |  73 )
#define SPELL_REVITALIZE           ( ( SKILL_CAT_SPELL << 16 ) |  74 )
#define SPELL_SANCTIFY             ( ( SKILL_CAT_SPELL << 16 ) |  75 )
#define SPELL_SENSE_LIFE           ( ( SKILL_CAT_SPELL << 16 ) |  76 )
#define SPELL_SHOCK                ( ( SKILL_CAT_SPELL << 16 ) |  77 )
#define SPELL_SILENCE              ( ( SKILL_CAT_SPELL << 16 ) |  78 )
#define SPELL_SLAY                 ( ( SKILL_CAT_SPELL << 16 ) |  79 )
#define SPELL_SLEEP                ( ( SKILL_CAT_SPELL << 16 ) |  80 )
#define SPELL_SLOW                 ( ( SKILL_CAT_SPELL << 16 ) |  81 )
#define SPELL_SUMMON               ( ( SKILL_CAT_SPELL << 16 ) |  82 )
#define SPELL_TAME                 ( ( SKILL_CAT_SPELL << 16 ) |  83 )
#define SPELL_TRUE_SIGHT           ( ( SKILL_CAT_SPELL << 16 ) |  84 )
#define SPELL_TURN_UNDEAD          ( ( SKILL_CAT_SPELL << 16 ) |  85 )
#define SPELL_VITALITY             ( ( SKILL_CAT_SPELL << 16 ) |  86 )
#define SPELL_WEB                  ( ( SKILL_CAT_SPELL << 16 ) |  87 )
#define SPELL_ASTRAL_GATE          ( ( SKILL_CAT_SPELL << 16 ) |  88 )
#define SPELL_FLOAT                ( ( SKILL_CAT_SPELL << 16 ) |  89 )
#define SPELL_PASS_DOOR            ( ( SKILL_CAT_SPELL << 16 ) |  90 )
#define SPELL_ACID_BLAST           ( ( SKILL_CAT_SPELL << 16 ) |  91 )
#define SPELL_ACID_STORM           ( ( SKILL_CAT_SPELL << 16 ) |  92 )
#define SPELL_FLY                  ( ( SKILL_CAT_SPELL << 16 ) |  93 )
#define SPELL_HASTE                ( ( SKILL_CAT_SPELL << 16 ) |  94 )
#define SPELL_PRISMIC_MISSILE      ( ( SKILL_CAT_SPELL << 16 ) |  95 )
#define SPELL_MAELSTROM            ( ( SKILL_CAT_SPELL << 16 ) |  96 )
#define SPELL_RESURRECT            ( ( SKILL_CAT_SPELL << 16 ) |  97 )
#define SPELL_BALM                 ( ( SKILL_CAT_SPELL << 16 ) |  98 )
#define SPELL_SURCEASE             ( ( SKILL_CAT_SPELL << 16 ) |  99 )
#define SPELL_LESSER_SUMMONING     ( ( SKILL_CAT_SPELL << 16 ) | 100 )
#define SPELL_REQUEST_ALLY         ( ( SKILL_CAT_SPELL << 16 ) | 101 )
#define SPELL_SENSE_DANGER         ( ( SKILL_CAT_SPELL << 16 ) | 102 )
#define SPELL_RESTORATION          ( ( SKILL_CAT_SPELL << 16 ) | 103 )
#define SPELL_FLAME_STRIKE         ( ( SKILL_CAT_SPELL << 16 ) | 104 )
#define SPELL_RESIST_FIRE          ( ( SKILL_CAT_SPELL << 16 ) | 105 )
#define SPELL_RESIST_COLD          ( ( SKILL_CAT_SPELL << 16 ) | 106 )
#define SPELL_INVULNERABILITY      ( ( SKILL_CAT_SPELL << 16 ) | 107 )
#define SPELL_TRANSFER             ( ( SKILL_CAT_SPELL << 16 ) | 108 )
#define SPELL_PROTECT_EVIL         ( ( SKILL_CAT_SPELL << 16 ) | 109 )
#define SPELL_PROTECT_GOOD         ( ( SKILL_CAT_SPELL << 16 ) | 110 )
#define SPELL_WIZARD_LOCK          ( ( SKILL_CAT_SPELL << 16 ) | 111 )
#define SPELL_YOUTH                ( ( SKILL_CAT_SPELL << 16 ) | 112 )
#define SPELL_MAJOR_ENCHANTMENT    ( ( SKILL_CAT_SPELL << 16 ) | 113 )
#define SPELL_AUGURY               ( ( SKILL_CAT_SPELL << 16 ) | 114 )
#define SPELL_RESIST_ACID          ( ( SKILL_CAT_SPELL << 16 ) | 115 )
#define SPELL_RESIST_SHOCK         ( ( SKILL_CAT_SPELL << 16 ) | 116 )
#define SPELL_THORN_SHIELD         ( ( SKILL_CAT_SPELL << 16 ) | 117 )
#define SPELL_ICE_LANCE            ( ( SKILL_CAT_SPELL << 16 ) | 118 )
#define SPELL_ION_SHIELD           ( ( SKILL_CAT_SPELL << 16 ) | 119 )
#define SPELL_METEOR_SWARM         ( ( SKILL_CAT_SPELL << 16 ) | 120 )
#define SPELL_GROUP_CRITICAL       ( ( SKILL_CAT_SPELL << 16 ) | 121 )
#define SPELL_GROUP_SERIOUS        ( ( SKILL_CAT_SPELL << 16 ) | 122 )
#define SPELL_PURIFY               ( ( SKILL_CAT_SPELL << 16 ) | 123 )
#define SPELL_WATER_BREATHING      ( ( SKILL_CAT_SPELL << 16 ) | 124 )
#define SPELL_WITHER               ( ( SKILL_CAT_SPELL << 16 ) | 125 )
#define SPELL_CONSTRUCT_GOLEM      ( ( SKILL_CAT_SPELL << 16 ) | 126 )
#define SPELL_CONFLAGRATION        ( ( SKILL_CAT_SPELL << 16 ) | 127 )
#define SPELL_CONJURE_ELEMENTAL    ( ( SKILL_CAT_SPELL << 16 ) | 128 )
#define SPELL_POULTICE             ( ( SKILL_CAT_SPELL << 16 ) | 129 )
#define SPELL_SCRY                 ( ( SKILL_CAT_SPELL << 16 ) | 130 )
#define SPELL_FIND_MOUNT           ( ( SKILL_CAT_SPELL << 16 ) | 131 )
#define SPELL_OBSCURE              ( ( SKILL_CAT_SPELL << 16 ) | 132 )
#define SPELL_SUSTENANCE           ( ( SKILL_CAT_SPELL << 16 ) | 133 )
#define SPELL_DEAFEN               ( ( SKILL_CAT_SPELL << 16 ) | 134 )
#define SPELL_WARD                 ( ( SKILL_CAT_SPELL << 16 ) | 135 )
#define SPELL_PARALYZE             ( ( SKILL_CAT_SPELL << 16 ) | 136 )
#define SPELL_ICE_SHIELD           ( ( SKILL_CAT_SPELL << 16 ) | 137 )
#define SPELL_DETECT_LAW           ( ( SKILL_CAT_SPELL << 16 ) | 138 )
#define SPELL_DETECT_CHAOS         ( ( SKILL_CAT_SPELL << 16 ) | 139 )
#define SPELL_PROTECT_LAW          ( ( SKILL_CAT_SPELL << 16 ) | 140 )
#define SPELL_PROTECT_CHAOS        ( ( SKILL_CAT_SPELL << 16 ) | 141 )

#define SONG_OF_MORALE             ( ( SKILL_CAT_SPELL << 16 ) | 142 )
#define SONG_OF_HEROISM            ( ( SKILL_CAT_SPELL << 16 ) | 143 )
#define SONG_OF_ZEAL               ( ( SKILL_CAT_SPELL << 16 ) | 144 )
#define SONG_OF_VALOR              ( ( SKILL_CAT_SPELL << 16 ) | 145 )
#define SONG_OF_GRACE              ( ( SKILL_CAT_SPELL << 16 ) | 146 )
#define SONG_OF_FORTITUDE          ( ( SKILL_CAT_SPELL << 16 ) | 147 )
#define SONG_OF_SENTINEL           ( ( SKILL_CAT_SPELL << 16 ) | 148 )
#define SONG_OF_LEGENDS            ( ( SKILL_CAT_SPELL << 16 ) | 149 )
#define SONG_OF_MYSTICS            ( ( SKILL_CAT_SPELL << 16 ) | 150 )
#define SONG_OF_WANDERER           ( ( SKILL_CAT_SPELL << 16 ) | 151 )
#define SONG_OF_WIND               ( ( SKILL_CAT_SPELL << 16 ) | 152 )
#define SONG_OF_WARD               ( ( SKILL_CAT_SPELL << 16 ) | 153 )

#define SPELL_ARC_LIGHTNING        ( ( SKILL_CAT_SPELL << 16 ) | 154 )
#define SPELL_LORE                 ( ( SKILL_CAT_SPELL << 16 ) | 155 )
#define SPELL_DARKVISION           ( ( SKILL_CAT_SPELL << 16 ) | 156 )

#define SPELL_SOFT_157	// <- RE-USE!
#define SPELL_SOFT_158
#define SPELL_SOFT_159
#define SPELL_SOFT_160
#define SPELL_SOFT_161
#define SPELL_SOFT_162
#define SPELL_SOFT_163
#define SPELL_SOFT_164

#define SPELL_BESTIARY             ( ( SKILL_CAT_SPELL << 16 ) | 165 )

/* Trade skill defines */

#define TRADE_COOKING              ( ( SKILL_CAT_TRADE << 16 ) |   0 )
#define TRADE_LEATHERING           ( ( SKILL_CAT_TRADE << 16 ) |   1 )
#define TRADE_METALURGY            ( ( SKILL_CAT_TRADE << 16 ) |   2 )
#define TRADE_WOODWORKING          ( ( SKILL_CAT_TRADE << 16 ) |   3 )

/* Weapon skill defines */

#define WEAPON_FIRST        	   ( ( SKILL_CAT_WEAPON << 16 ) |   0 )
#define WEAPON_UNARMED        	   ( ( SKILL_CAT_WEAPON << 16 ) |   0 )
#define WEAPON_DAGGER         	   ( ( SKILL_CAT_WEAPON << 16 ) |   1 )
#define WEAPON_SWORD          	   ( ( SKILL_CAT_WEAPON << 16 ) |   2 )
#define WEAPON_CLUB           	   ( ( SKILL_CAT_WEAPON << 16 ) |   3 )
#define WEAPON_STAFF          	   ( ( SKILL_CAT_WEAPON << 16 ) |   4 )
#define WEAPON_POLEARM        	   ( ( SKILL_CAT_WEAPON << 16 ) |   5 )
#define WEAPON_MACE           	   ( ( SKILL_CAT_WEAPON << 16 ) |   6 )
#define WEAPON_WHIP           	   ( ( SKILL_CAT_WEAPON << 16 ) |   7 )
#define WEAPON_AXE            	   ( ( SKILL_CAT_WEAPON << 16 ) |   8 )
#define WEAPON_BOW            	   ( ( SKILL_CAT_WEAPON << 16 ) |   9 )
#define WEAPON_SPEAR          	   ( ( SKILL_CAT_WEAPON << 16 ) |  10 )


#endif // tfe_abil_h
