#ifndef tfe_library_h
#define tfe_library_h


#define LIB_BUF_LEN	(3*MAX_STRING_LENGTH)
extern char lib_buf [ LIB_BUF_LEN ];


/*
 *   VARIABLES
 */

extern obj_data*     var_container;
extern obj_data*     var_act_obj;
extern char_data*    var_victim;  
extern char_data*    var_mob; 
extern char_data*    var_ch;
extern obj_data*     var_obj;
extern room_data*    var_room;
extern const char   *var_cmd;
extern const char   *var_arg;
extern int           var_i;
extern int           var_j;
extern int           var_k;
extern int           var_l;
extern int           var_m;
extern int           var_n;
extern char_data    *var_rch;
extern exit_data    *var_exit;
extern const default_data *var_def;
extern int var_def_type;
extern thing_data   *var_thing;
extern thing_array   var_list;

extern char_data *orig_ch;
extern char_data *orig_victim;


/*
 *   OPERATORS
 */

cfunc code_and;
cfunc code_eor;
cfunc code_or;
cfunc code_minus_equal;
cfunc code_plus_equal;
cfunc code_mult_equal;
cfunc code_div_equal;
cfunc code_rem_equal;
cfunc code_set_equal;
cfunc code_not_equal;
cfunc code_is_equal;
cfunc code_gt;
cfunc code_lt;
cfunc code_le;
cfunc code_ge;
cfunc code_add;
cfunc code_subtract;
cfunc code_multiply;
cfunc code_divide;
cfunc code_remainder;
cfunc code_streq;
cfunc code_strneq;
cfunc code_list_assign;
cfunc code_pre_incr;
cfunc code_pre_decr;
cfunc code_post_incr;
cfunc code_post_decr;


/*
 *   BITWISE OPERATORS
 */

cfunc code_bit_and;
cfunc code_bit_or;
cfunc code_bit_xor;
cfunc code_lshift;
cfunc code_rshift;
cfunc code_bit_and_equal;
cfunc code_bit_or_equal;
cfunc code_bit_xor_equal;
cfunc code_lshift_equal;
cfunc code_rshift_equal;


/*
 *   AUTOMATIC TYPE CONVERSIONS
 */

cfunc code_conv_int_str;
cfunc code_conv_exit_str;
cfunc code_conv_int_dir;
cfunc code_conv_dir_int;


/*
 *   SCRIPT FUNCTIONS
 */

cfunc code_acid_message;
cfunc code_acode;
cfunc code_act_area;
cfunc code_act_neither;
cfunc code_act_notchar;
cfunc code_act_notvict;
cfunc code_act_room;
cfunc code_act_tochar;
cfunc code_append;
cfunc code_area;
cfunc code_assign_quest;
cfunc code_attack;
cfunc code_attack_acid;
cfunc code_attack_backstab;
cfunc code_attack_charge;
cfunc code_attack_cold;
cfunc code_attack_fire;
cfunc code_attack_garrote;
cfunc code_attack_magic;
cfunc code_attack_mind;
cfunc code_attack_offhand;
cfunc code_attack_room;
cfunc code_attack_shock;
cfunc code_attack_sound;
cfunc code_attack_weapon;
cfunc code_beep;
cfunc code_beetle;
cfunc code_bug;
cfunc code_burn_web;
cfunc code_can_attack;
cfunc code_can_bash;
cfunc code_can_fly;
cfunc code_can_hear;
cfunc code_can_move;
cfunc code_can_see;
cfunc code_can_see_char;
cfunc code_can_see_obj;
cfunc code_can_see_room;
cfunc code_can_speak;
cfunc code_cardinal;
cfunc code_cast_mana;
cfunc code_cast_spell;
cfunc code_cflag;
cfunc code_chair;
cfunc code_char_affected;
cfunc code_char_in_room;
cfunc code_character;
cfunc code_check_skill;
cfunc code_clan_abbrev;
cfunc code_clan_name;
cfunc code_class;
cfunc code_close;
cfunc code2_close;
cfunc code_coin_value;
cfunc code_cold_message;
cfunc code_contents;
cfunc code_dam_acid;
cfunc code_dam_cold;
cfunc code_dam_fire;
cfunc code_dam_magic;
cfunc code_dam_message;
cfunc code_dam_mind;
cfunc code_dam_physical;
cfunc code_dam_shock;
cfunc code_dam_sound;
cfunc code_date_day;
cfunc code_date_first_year;
cfunc code_date_month;
cfunc code_date_weekday;
cfunc code_date_year;
cfunc code_days_in_month;
cfunc code_deep_water;
cfunc code_default;
cfunc code_dflag;
cfunc code_dice;
cfunc code_dir_name;
cfunc code_direction;
cfunc code_disembark;
cfunc code_dismount;
cfunc code_dispel_affect;
cfunc code_do_spell;
cfunc code_doing_quest;
cfunc code_done_quest;
cfunc code_door;
cfunc code_drain_stat;
cfunc code_drain_exp;
cfunc code_drop;
cfunc code_embark;
cfunc code_fail_quest;
cfunc code_failed_quest;
cfunc code_find_player;
cfunc code_find_room;
cfunc code_find_skill;
cfunc code_find_stat;
cfunc code_fire_message;
cfunc code_first_word;
cfunc code_followers;
cfunc code_get_desc;
cfunc code_get_money;
cfunc code_get_quest;
cfunc code_get_religion;
cfunc code_get_room;
cfunc code_get_sex;
cfunc code_has_key;
cfunc code_has_obj;
cfunc code_has_obj_flag;
cfunc code_has_prepared;
cfunc code_has_reset;
cfunc code_has_quest;
cfunc code_has_wear_part;
cfunc code_heal;
cfunc code_heal_victim;
cfunc code_inflict;
cfunc code_inflict_acid;
cfunc code_inflict_cold;
cfunc code_inflict_fire;
cfunc code_inflict_magic;
cfunc code_inflict_mind;
cfunc code_inflict_shock;
cfunc code_inflict_sound;
cfunc code_insert;
cfunc code_interpret;
cfunc code_is_aggressive;
cfunc code_is_altered;
cfunc code_is_casting;
cfunc code_is_confused_pet;
cfunc code_is_creature;
cfunc code_is_drowning;
cfunc code_is_empty;
cfunc code_is_entangled;
cfunc code_is_exhausted;
cfunc code_is_family;
cfunc code_is_fighting;
cfunc code_is_follower;
cfunc code_is_group;
cfunc code_is_locked;
cfunc code2_is_locked;
cfunc code_is_meditating;
cfunc code_is_mob;
cfunc code_is_mounted;
cfunc code_is_name;
cfunc code_is_not_player;
cfunc code_is_open;
cfunc code2_is_open;
cfunc code_is_pet;
cfunc code_is_player;
cfunc code_is_race;
cfunc code_is_resting;
cfunc code_is_searching;
cfunc code_is_silenced;
cfunc code_is_sleeping;
cfunc code_is_standing;
cfunc code_is_submerged;
cfunc code_item;
cfunc code_junk;
cfunc code_junk_mob;
cfunc code_junk_obj;
cfunc code_leader;
cfunc code_leads_to;
cfunc code_length;
cfunc code_light;
cfunc code_list_name;
cfunc code_lock;
cfunc code2_lock;
cfunc code_magic_message;
cfunc code_mail;
cfunc code_min_move;
cfunc code_mind_message;
cfunc code_mpcode;
cfunc code_mprog;
cfunc code_mload;
cfunc code_mob;
cfunc code_mob_act;
cfunc code_mob_in_room;
cfunc code_modify_mana;
cfunc code_modify_move;
cfunc code_moon_phase;
cfunc code_mount;
cfunc code_move_name;
cfunc code_move_leaves;
cfunc code_move_arrives;
cfunc code_name;
cfunc code_num_in_room;
cfunc code_num_mob;
cfunc code_number;
cfunc code_oload;
cfunc code_obj_affected;
cfunc code_obj_condition;
cfunc code_obj_cost;
cfunc code_obj_count;
cfunc code_obj_durability;
cfunc code_obj_flag;
cfunc code_obj_in_room;
cfunc code_obj_level;
cfunc code_obj_limit;
cfunc code_obj_to_char;
cfunc code_obj_to_container;
cfunc code_obj_to_room;
cfunc code_obj_type;
cfunc code_obj_value;
cfunc code_object;
cfunc code_offhand;
cfunc code_opcode;
cfunc code_oprog;
cfunc code_open;
cfunc code2_open;
cfunc code_ordinal;
cfunc code_owns;
cfunc code_path;
cfunc code_path_end;
cfunc code_path_next;
cfunc code_path_retry;
cfunc code_path_target;
cfunc code_plague;
cfunc code_player;
cfunc code_players_area;
cfunc code_players_room;
cfunc code_poison;
cfunc code_prepend;
cfunc code_race;
cfunc code_random;
cfunc code_rand_char;
cfunc code_rand_player;
cfunc code_remove;
cfunc code_remove_cflag;
cfunc code_remove_dflag;
cfunc code_remove_obj_flag;
cfunc code_remove_quest;
cfunc code_remove_rflag;
cfunc code_replace_obj;
cfunc code_reputation;
cfunc code_reset_appear;
cfunc code_reverse;
cfunc code_rflag;
cfunc code_rider;
cfunc code_room;
cfunc code_room_next;
cfunc code_selected;
cfunc code_send_not_char;
cfunc code_send_to_area;
cfunc code_send_to_char;
cfunc code_send_to_room;
cfunc code_set_adj_p;
cfunc code_set_adj_s;
cfunc code_set_after;
cfunc code_set_before;
cfunc code_set_cflag;
cfunc code_set_color;
cfunc code_set_cost;
cfunc code_set_delay;
cfunc code_set_desc;
cfunc code_set_dflag;
cfunc code_set_keywords;
cfunc code_set_light;
cfunc code_set_long_p;
cfunc code_set_long_s;
cfunc code_set_mob_timer;
cfunc code_set_mount;
cfunc code_set_name;
cfunc code_set_obj_flag;
cfunc code_set_obj_timer;
cfunc code_set_obj_value;
cfunc code_set_owner;
cfunc code_set_plural;
cfunc code_set_prefix_p;
cfunc code_set_prefix_s;
cfunc code_set_quest;
cfunc code_set_religion;
cfunc code_set_resting;
cfunc code_set_rflag;
cfunc code_set_sentinel;
cfunc code_set_singular;
cfunc code_set_standing;
cfunc code_set_victim;
cfunc code_set_weight;
cfunc code_shield;
cfunc code_shock_message;
cfunc code_show;
cfunc code2_show;
cfunc code_show_map;
cfunc code_size;
cfunc code_skill;
cfunc code_skip_word;
cfunc code_sound_message;
cfunc code_spell_affect;
cfunc code_spell_damage;
cfunc code_spell_duration;
cfunc code_stop_camouflage;
cfunc code_stop_hide;
cfunc code_string;
cfunc code_summon;
cfunc code_take;
cfunc code_tell;
cfunc code_time_hour;
cfunc code_time_minute;
cfunc code_transfer;
cfunc code_transfer_all;
cfunc code_trigger_oprog;
cfunc code_trigger_mprog;
cfunc code_trigger_acode;
cfunc code_unlock;
cfunc code2_unlock;
cfunc code_update_quest;
cfunc code_use_skill;
cfunc code_vnum;
cfunc code_wait;
cfunc code_water_logged;
cfunc code_water_shock;
cfunc code_wearing;
cfunc code_wearing_obj;
cfunc code_wearing_obj_flag;
cfunc code_weight;
cfunc code_where;
cfunc code_wield;
cfunc code_word;
cfunc code_worn;


#endif // tfe_library_h
